## calligra 3.2.1+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)

project(calligra)

message(STATUS "Using CMake version: ${CMAKE_VERSION}")

if (POLICY CMP0002)
    cmake_policy(SET CMP0002 OLD)
endif()
if (POLICY CMP0017)
    cmake_policy(SET CMP0017 NEW)
endif ()
if (POLICY CMP0022)
    cmake_policy(SET CMP0022 OLD)
endif ()
if (POLICY CMP0026)
    cmake_policy(SET CMP0026 OLD)
endif()
if (POLICY CMP0046)
    cmake_policy(SET CMP0046 OLD)
endif ()
if (POLICY CMP0059)
    cmake_policy(SET CMP0059 OLD)
endif()
if (POLICY CMP0063)
    cmake_policy(SET CMP0063 NEW)
endif()
if (POLICY CMP0071)
    cmake_policy(SET CMP0071 NEW)
endif()

# ensure out-of-source build
string(COMPARE EQUAL "${CMAKE_SOURCE_DIR}" "${CMAKE_BINARY_DIR}" isBuildInSource)
if(isBuildInSource)
    message(FATAL_ERROR "Compiling Calligra inside the source folder is not possible.\nPlease refer to the build instruction: https://community.kde.org/Calligra/Building/3\nYou need to clean up the source folder from all build artifacts just created, otherwise further building attempts will fail again: With a git repo, you can use \"git clean -df\" in the toplevel source folder (attention! will remove also uncommited changes to the source code). With sources from a file bundle (like a zip file), delete the source folder and unbundle the sources again.")
endif()

######################
#######################
## Constants defines ##
#######################
######################

# define common versions of Calligra applications, used to generate calligraversion.h
# update these version for every release:
set(CALLIGRA_VERSION_STRING "3.2.1")
set(CALLIGRA_STABLE_VERSION_MAJOR 3) # 3 for 3.x, 4 for 4.x, etc.
set(CALLIGRA_STABLE_VERSION_MINOR 2) # 0 for 3.0, 1 for 3.1, etc.
set(CALLIGRA_VERSION_RELEASE 1)     # 89 for Alpha, increase for next test releases, set 0 for first Stable, etc.
#set(CALLIGRA_ALPHA 1) # uncomment only for Alpha
# set(CALLIGRA_BETA 1) # uncomment only for Beta
#set(CALLIGRA_RC 1) # uncomment only for RC
set(CALLIGRA_YEAR 2020) # update every year

if(NOT DEFINED CALLIGRA_ALPHA AND NOT DEFINED CALLIGRA_BETA AND NOT DEFINED CALLIGRA_RC)
    set(CALLIGRA_STABLE 1) # do not edit
endif()

message(STATUS "Calligra version: ${CALLIGRA_VERSION_STRING}")

# Define the generic version of the Calligra libraries here
# This makes it easy to advance it when the next Calligra release comes.
# 14 was the last GENERIC_CALLIGRA_LIB_VERSION_MAJOR of the previous Calligra series
# (2.x) so we're starting with 15 in 3.x series.
if(CALLIGRA_STABLE_VERSION_MAJOR EQUAL 3)
    math(EXPR GENERIC_CALLIGRA_LIB_VERSION_MAJOR "${CALLIGRA_STABLE_VERSION_MINOR} + 15")
else()
    # let's make sure we won't forget to update the "15"
    message(FATAL_ERROR "Reminder: please update offset == 15 used to compute GENERIC_CALLIGRA_LIB_VERSION_MAJOR to something bigger")
endif()
set(GENERIC_CALLIGRA_LIB_VERSION "${GENERIC_CALLIGRA_LIB_VERSION_MAJOR}.0.0")
set(GENERIC_CALLIGRA_LIB_SOVERSION "${GENERIC_CALLIGRA_LIB_VERSION_MAJOR}")

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH}
    "${CMAKE_SOURCE_DIR}/cmake/modules")

message("Module path:" ${CMAKE_MODULE_PATH})

# fetch git revision for the current build

set(CALLIGRA_GIT_SHA1_STRING "")
set(CALLIGRA_GIT_BRANCH_STRING "")

include(GetGitRevisionDescription)
get_git_head_revision(GIT_REFSPEC GIT_SHA1)
get_git_branch(GIT_BRANCH)

if(GIT_SHA1 AND GIT_BRANCH)
    string(SUBSTRING ${GIT_SHA1} 0 7 GIT_SHA1)
    set(CALLIGRA_GIT_SHA1_STRING ${GIT_SHA1})
    set(CALLIGRA_GIT_BRANCH_STRING ${GIT_BRANCH})
endif()

if(NOT DEFINED RELEASE_BUILD)
    # estimate mode by CMAKE_BUILD_TYPE content if not set on cmdline
    string(TOLOWER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_TOLOWER)
    set(RELEASE_BUILD_TYPES "release" "relwithdebinfo" "minsizerel")
    list(FIND RELEASE_BUILD_TYPES "${CMAKE_BUILD_TYPE_TOLOWER}" INDEX)
    if (INDEX EQUAL -1)
	set(RELEASE_BUILD FALSE)
    else()
	set(RELEASE_BUILD TRUE)
    endif()
endif()
message(STATUS "Release build: ${RELEASE_BUILD}")

# use CPP-11
if (CMAKE_VERSION VERSION_LESS "3.1")
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
else ()
    set (CMAKE_CXX_STANDARD 11)
endif ()

############
#############
## Options ##
#############
############

option(GHNS "support Get Hot New Stuff" OFF)
option(PACKAGERS_BUILD "Build support of multiple CPU architectures in one binary. Should be used by packagers only." ON)

#######################
########################
## Productset setting ##
########################
#######################

# For predefined productsets see the definitions in CalligraProducts.cmake and
# in the files in the folder cmake/productsets.

# Finding out the products & features to build is done in 5 steps:
# 1. have the user define the products/features wanted, by giving a productset
# 2. estimate all additional required products/features
# 3. estimate which of the products/features can be build by external deps
# 4. find which products/features have been temporarily disabled due to problems
# 5. estimate which of the products/features can be build by internal deps

# get the special macros
include(CalligraProductSetMacros)

# get the definitions of products, features and product sets
include(CalligraProducts.cmake)

set(PRODUCTSET_DEFAULT "ALL")

if(NOT PRODUCTSET)
    set(PRODUCTSET ${PRODUCTSET_DEFAULT} CACHE STRING "Set of products/features to build" FORCE)
endif()

if (RELEASE_BUILD)
    set(CALLIGRA_SHOULD_BUILD_STAGING FALSE)
    if(BUILD_UNMAINTAINED)
	set(CALLIGRA_SHOULD_BUILD_UNMAINTAINED TRUE)
    else()
	set(CALLIGRA_SHOULD_BUILD_UNMAINTAINED FALSE)
    endif()
else ()
    set(CALLIGRA_SHOULD_BUILD_STAGING TRUE)
    set(CALLIGRA_SHOULD_BUILD_UNMAINTAINED TRUE)
endif ()

# finally choose products/features to build
calligra_set_productset(${PRODUCTSET})

##########################
###########################
## Look for ECM, Qt, KF5 ##
###########################
##########################

find_package(ECM 5.19 REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH} ${ECM_KDE_MODULE_DIR})

# ECM KDE macros (include first, to have their policies and settings effect all other macros)
include(KDEInstallDirs)
include(KDECMakeSettings NO_POLICY_SCOPE)
include(KDECompilerSettings NO_POLICY_SCOPE)
# CMake macros
include(CMakePackageConfigHelpers)
include(WriteBasicConfigVersionFile)
include(CheckFunctionExists)
include(CheckTypeSize)
include(CheckIncludeFile)
include(GenerateExportHeader)
include(FeatureSummary)
# ECM macros
include(ECMOptionalAddSubdirectory)
include(ECMInstallIcons)
include(ECMAddAppIcon)
include(ECMSetupVersion)
include(ECMAddTests)
include(ECMMarkAsTest)
include(ECMMarkNonGuiExecutable)
include(ECMGenerateHeaders)
# own macros
include(MacroBoolTo01)
include(MacroOptionalFindPackage)
include(MacroEnsureVersion)
include(MacroDesktopToJson)


set(REQUIRED_KF5_VERSION "5.7.0")

find_package(KF5 ${REQUIRED_KF5_VERSION} REQUIRED
    COMPONENTS
    Archive
    Codecs
    Completion
    Config
    ConfigWidgets
    CoreAddons
    DBusAddons
    DocTools
    GuiAddons
    I18n
    IconThemes
    ItemViews
    JobWidgets
    KCMUtils
    KDELibs4Support
    KIO
    Kross
    Notifications
    NotifyConfig
    Parts
    Sonnet
    TextWidgets
    Wallet
    WidgetsAddons
    WindowSystem
    XmlGui
    )

find_package(KF5Activities)
find_package(KF5KHtml)

set_package_properties(KF5Activities PROPERTIES
    TYPE OPTIONAL
    )
set_package_properties(KF5KHtml PROPERTIES
    PURPOSE "Required for HTML2ODS import filter"
    TYPE OPTIONAL
    )

if(KF5Activities_FOUND)
    set(HAVE_KACTIVITIES TRUE)
endif()

if(${KF5_VERSION} VERSION_LESS "5.16.0")
    set(CALLIGRA_OLD_PLUGIN_METADATA TRUE)
endif()


set(REQUIRED_QT_VERSION "5.3.0")

find_package(Qt5 ${REQUIRED_QT_VERSION} REQUIRED
    COMPONENTS
    Core
    Gui
    Network
    PrintSupport
    Svg
    Test
    Widgets
    Xml
    )
find_package(Qt5 ${REQUIRED_QT_VERSION} QUIET
    COMPONENTS
    DBus
    OpenGL
    Quick
    QuickWidgets
    Sql
)

# Qt5Declarative was removed in Qt 5.6.0 so search for it in a separate call
# Including it in a collected find_package(Qt5 ...) call can lead to a fatal not-found error:
# * Qt5 (required version >= 5.3.0)
find_package(Qt5Declarative ${REQUIRED_QT_VERSION} QUIET)

set_package_properties(Qt5DBus PROPERTIES
    TYPE RECOMMENDED
    )
set_package_properties(Qt5Declarative PROPERTIES
    PURPOSE "Required for QtQuick1 components"
    TYPE RECOMMENDED
    )
set_package_properties(Qt5OpenGL PROPERTIES
    PURPOSE "Required for QtQuick1 components"
    TYPE RECOMMENDED
    )
set_package_properties(Qt5Quick PROPERTIES
    PURPOSE "Required for QtQuick2 components"
    TYPE RECOMMENDED
    )
set_package_properties(Qt5QuickWidgets PROPERTIES
    PURPOSE "Required for Calligra Gemini"
    TYPE RECOMMENDED
    )
set_package_properties(Qt5Sql PROPERTIES
    PURPOSE "Optional for Sheets' database connection"
    TYPE OPTIONAL
    )
set_package_properties(Qt5WebKit PROPERTIES
    PURPOSE "Required for Braindump's Web shape"
    TYPE OPTIONAL
    )

set(HAVE_OPENGL ${Qt5OpenGL_FOUND})


if (GHNS)
    find_package(Attica 3.0)
    find_package(NewStuff)
    set_package_properties(Attica PROPERTIES
	DESCRIPTION "Attica is used for Get Hot New Stuff."
	URL "https://commits.kde.org/attica"
	TYPE OPTIONAL
	)

    if (NOT LIBATTICA_FOUND)
	set(GHNS FALSE)
    else ()
	message(STATUS "WARNING: You are compiling with Get Hot New Stuff enabled. Do not do that when building distribution packages. GHNS is unusable these days until someone starts maintaining it again.")
    endif ()
endif ()

find_package(X11)
if(X11_FOUND)
    find_package(Qt5 ${REQUIRED_QT_VERSION} REQUIRED
	COMPONENTS
	X11Extras
	)
    set(HAVE_X11 TRUE)
    add_definitions(-DHAVE_X11)
else()
    set(HAVE_X11 FALSE)
endif()

# use sane compile flags
add_definitions(
    -DQT_USE_QSTRINGBUILDER
    -DQT_STRICT_ITERATORS
    -DQT_NO_SIGNALS_SLOTS_KEYWORDS
    -DQT_NO_URL_CAST_FROM_STRING
    -DQT_NO_CAST_TO_ASCII
    )

# only with this definition will all the FOO_TEST_EXPORT macro do something
# TODO: check if this can be moved to only those places which make use of it,
# to reduce global compiler definitions that would trigger a recompile of
# everything on a change (like adding/removing tests to/from the build)
if(BUILD_TESTING)
    add_definitions(-DCOMPILING_TESTS)
endif()

# overcome some platform incompatibilities
if(WIN32)
    if(NOT MINGW)
	include_directories(${CMAKE_CURRENT_SOURCE_DIR}/winquirks)
	add_definitions(-D_USE_MATH_DEFINES)
	add_definitions(-DNOMINMAX)
    endif()
    set(WIN32_PLATFORM_NET_LIBS ws2_32.lib netapi32.lib)
endif()

###########################
############################
## Required dependencies  ##
############################
###########################

find_package(Perl REQUIRED)
find_package(ZLIB REQUIRED)

add_definitions(-DBOOST_ALL_NO_LIB)
find_package(Boost REQUIRED COMPONENTS system) # for pigment and stage
if (NOT Boost_FOUND)
    message(FATAL_ERROR "Did not find Boost. Boost is required for the core libraries, stage, sheets.")
endif ()

###########################
############################
## Optional dependencies  ##
############################
###########################


##
## Check for OpenEXR
##

macro_optional_find_package(OpenEXR)
macro_bool_to_01(OPENEXR_FOUND HAVE_OPENEXR)

##
## Test for GNU Scientific Library
##
macro_optional_find_package(GSL 1.7)
set_package_properties(GSL_FOUND PROPERTIES
    DESCRIPTION "GNU Scientific Library"
    URL "https://www.gnu.org/software/gsl"
    PURPOSE "Required by Sheets' solver plugin"
    TYPE OPTIONAL
    )
macro_bool_to_01(GSL_FOUND HAVE_GSL)
configure_file(config-gsl.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-gsl.h )

##
## Test for Phonon4Qt5
##
find_package(Phonon4Qt5 QUIET)
set_package_properties(Phonon4Qt5 PROPERTIES
    DESCRIPTION "Abstraction lib for multimedia applications"
    URL "https://www.kde.org/"
    PURPOSE "Required by Stage event actions and Videoshape plugin"

=== gemini/CMakeLists.txt ===
project(calligragemini)

# TEMPORARY: for  Qt5/KF5 build porting phase deprecation warnings are only annoying noise
# if (CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_IS_GNUC)
    # add_definitions(-Wno-deprecated -Wno-deprecated-declarations)
# endif ()
add_subdirectory(lib)

if (WIN32)
    option(ENABLE_GEMINI_STARTUP_MAGIC "Enable Gemini's windows startup magic" ON)

    if (ENABLE_GEMINI_STARTUP_MAGIC)
        add_definitions(-DGEMINI_ENABLE_STARTUP_MAGIC)
    endif ()
endif ()

include_directories(${KOMAIN_INCLUDES}
                    ${CMAKE_CURRENT_SOURCE_DIR}
                    ${CMAKE_CURRENT_SOURCE_DIR}/..
                    ${CMAKE_CURRENT_BINARY_DIR}
                    ${CMAKE_SOURCE_DIR}/libs/pageapp
                    ${CMAKE_SOURCE_DIR}/stage
                    ${CMAKE_SOURCE_DIR}/stage/part
                    ${CMAKE_SOURCE_DIR}/words
                    ${CMAKE_SOURCE_DIR}/words/part)

set(calligragemini_SRCS
    main.cpp
    MainWindow.cpp
    desktopviewproxy.cpp
    Constants.cpp
    DocumentListModel.cpp
    DocumentManager.cpp
    ProgressProxy.cpp
    QmlGlobalEngine.cpp
    RecentFileManager.cpp
    Settings.cpp
    SimpleTouchArea.cpp
#     TouchDeclarativeView.cpp
    PropertyContainer.cpp
    Theme.cpp
    ToolManager.cpp
    ParagraphStylesModel.cpp
    KeyboardModel.cpp
    ScribbleArea.cpp
    RecentImageImageProvider.cpp
    RecentFilesModel.cpp
    TemplatesModel.cpp
    TemplateVariantsModel.cpp
    CloudAccountsModel.cpp
)

set(thumbnailhelper_SRCS
    thumbnailhelper.cpp
    ThumbnailHelperImpl.cpp
)

file(GLOB ICONS_SRCS "pics/*-apps-calligragemini.png")
ecm_add_app_icon(calligragemini_SRCS ICONS ${ICONS_SRCS})

# Thumbnail helper application
# =============================================================================

add_executable(calligrageminithumbnailhelper ${thumbnailhelper_SRCS})
target_link_libraries(calligrageminithumbnailhelper
    komain
    KF5::Crash # needed to explicitly disable drkonqi if any plugin links to kdelibs4support
)

# Calligra Gemini application
# =============================================================================

add_executable(calligragemini ${calligragemini_SRCS})

target_link_libraries(calligragemini
    Qt5::Quick
    Qt5::QuickWidgets
    Qt5::Qml
    Qt5::Gui
    Qt5::Core
    KF5::IconThemes
    komain
    wordsprivate
    calligrastageprivate
    gemini
)

install(TARGETS   calligragemini calligrageminithumbnailhelper ${INSTALL_TARGETS_DEFAULT_ARGS})
install(PROGRAMS  org.kde.calligragemini.desktop               DESTINATION ${XDG_APPS_INSTALL_DIR})
install(FILES org.kde.calligragemini.appdata.xml DESTINATION ${KDE_INSTALL_METAINFODIR})
#install(FILES     calligrageminirc calligrageminipanelsrc DESTINATION ${CONFIG_INSTALL_DIR} )
install(FILES     calligragemini.qml                   DESTINATION ${DATA_INSTALL_DIR}/calligragemini)
#install(FILES     calligragemini.rc                    DESTINATION ${DATA_INSTALL_DIR}/calligragemini)
install(DIRECTORY qml                                       DESTINATION ${DATA_INSTALL_DIR}/calligragemini)
install(DIRECTORY themes                                    DESTINATION ${DATA_INSTALL_DIR}/calligragemini)
if(APPLE)
   install( FILES ${CMAKE_CURRENT_BINARY_DIR}/calligragemini_SRCS.icns DESTINATION ${BUNDLE_INSTALL_DIR}/calligragemini.app/Contents/Resources)
endif()

add_subdirectory(pics)
add_subdirectory(cloud)

=== libs/CMakeLists.txt ===
add_definitions(
  -DTRANSLATION_DOMAIN=\"calligra\"
)

if (SHOULD_BUILD_LIB_CALLIGRA)
    add_subdirectory( version )
    add_subdirectory( plugin )
    add_subdirectory( widgetutils )
    add_subdirectory( widgets )
    add_subdirectory( store )
    add_subdirectory( odf )
    add_subdirectory( textlayout )
    add_subdirectory( text )
    add_subdirectory( flake )
    add_subdirectory( basicflakes )
    add_subdirectory( pigment )
    add_subdirectory( kundo2 )
endif ()

if (SHOULD_BUILD_LIB_KOMAIN)
    add_subdirectory( main )
endif ()

if (SHOULD_BUILD_FEATURE_SCRIPTING)
    add_subdirectory( kross )
endif ()

if (SHOULD_BUILD_LIB_KOVECTORIMAGE)
    add_subdirectory( vectorimage )
endif ()

if (SHOULD_BUILD_LIB_KOPAGEAPP)
    add_subdirectory( pageapp )
endif ()

if (SHOULD_BUILD_FEATURE_RDF)
    add_subdirectory( rdf )
endif ()

=== plugins/CMakeLists.txt ===
if(MSVC OR (WIN32 AND "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel"))
  # avoid "cannot open file 'LIBC.lib'" error
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} /NODEFAULTLIB:LIBC.LIB")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /NODEFAULTLIB:LIBC.LIB")
endif()


if (SHOULD_BUILD_PLUGIN_COLORENGINES)
    add_subdirectory( colorengines )
endif ()

if (SHOULD_BUILD_PLUGIN_MUSICSHAPE)
    add_subdirectory( musicshape )
endif ()

if (SHOULD_BUILD_PLUGIN_SPACENAVIGATOR)
    macro_optional_find_package(Spnav)
    set_package_properties(Spnav PROPERTIES
        DESCRIPTION "3Dconnexion device driver and SDK"
        URL "http://spacenav.sourceforge.net/"
        PURPOSE "Required by SpaceNavigator 3D mouse plugin"
        TYPE OPTIONAL
    )
    if (SPNAV_FOUND)
        add_subdirectory( spacenavigator )
    endif ()
endif ()

if (SHOULD_BUILD_PLUGIN_ARTISTICTEXTSHAPE)
    add_subdirectory( artistictextshape )
endif ()

if (SHOULD_BUILD_PLUGIN_DOCKERS)
    add_subdirectory( dockers )
endif ()

if (SHOULD_BUILD_PLUGIN_TEXTEDITING)
    add_subdirectory( textediting )
endif()

if (SHOULD_BUILD_PLUGIN_DEFAULTTOOLS)
    add_subdirectory( defaultTools )
endif ()

if (SHOULD_BUILD_PLUGIN_PATHSHAPES)
    add_subdirectory( pathshapes )
endif ()

if (SHOULD_BUILD_PLUGIN_VARIABLES)
    add_subdirectory( variables )
endif ()

if (SHOULD_BUILD_PLUGIN_CHARTSHAPE)
    add_subdirectory( chartshape )
endif ()

if (SHOULD_BUILD_PLUGIN_PICTURESHAPE)
    add_subdirectory( pictureshape )
endif ()

if (SHOULD_BUILD_PLUGIN_TEXTSHAPE)
    add_subdirectory( textshape )
endif()

if (SHOULD_BUILD_PLUGIN_PLUGINSHAPE)
    add_subdirectory( pluginshape )
endif ()

if (SHOULD_BUILD_PLUGIN_FORMULASHAPE)
    add_subdirectory( formulashape )
endif ()

if (SHOULD_BUILD_PLUGIN_VECTORSHAPE)
    # ??? old comment: as the vector shape depends on filters subdir (not really intuitive) lets allow disabling
    add_subdirectory( vectorshape )
endif ()

if (SHOULD_BUILD_PLUGIN_VIDEOSHAPE)
    add_subdirectory( videoshape )
endif ()

if(SHOULD_BUILD_PLUGIN_SEMANTICITEMS)
    add_subdirectory( semanticitems )
endif()

if(SHOULD_BUILD_PLUGIN_SHAPEFILTEREFFECTS)
    add_subdirectory( shapefiltereffects )
endif()

if(SHOULD_BUILD_PLUGIN_STENCILSDOCKER)
    add_subdirectory( stencilsdocker)
endif()

if(SHOULD_BUILD_PLUGIN_KARBONPLUGINS)
    add_subdirectory( karbonplugins )
endif()

#add_subdirectory( videoshape )
#add_subdirectory( commentshape )

add_subdirectory( staging )

=== sheets/CMakeLists.txt ===
project(calligra-sheets)

# TEMPORARY: for  Qt5/KF5 build porting phase deprecation warnings are only annoying noise
if (CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_IS_GNUC)
    add_definitions(-Wno-deprecated -Wno-deprecated-declarations)
endif ()

list(APPEND CMAKE_AUTOMOC_MACRO_NAMES "CALLIGRA_SHEETS_EXPORT_FUNCTION_MODULE")

if (SHOULD_BUILD_PART_SHEETS)

include_directories( ${CMAKE_SOURCE_DIR}/interfaces
                    ${KOMAIN_INCLUDES}
                    ${KOTEXT_INCLUDES}
                    ${TEXTLAYOUT_INCLUDES}
                    ${Boost_INCLUDE_DIR}
                    ${EIGEN3_INCLUDE_DIR} )

# have their own translation domain
### TODO: The tableshape needs a rewrite,
### it has been obsoleted by the implementation of texttables
#add_subdirectory( shape )

add_subdirectory( plugins )

add_definitions(-DTRANSLATION_DOMAIN=\"calligrasheets\")

add_subdirectory( data )
if(BUILD_TESTING)
    add_subdirectory( tests )
endif()
add_subdirectory( dtd )
add_subdirectory( functions )

#add_definitions(-DCALLIGRA_SHEETS_MT)

if(NOT Qt5Sql_FOUND)
    add_definitions(-DQT_NO_SQL)
endif()

########### next target ###############
set (chart_DIR_SRCS
    chart/ChartDatabaseSelectorFactory.cpp
    chart/ChartDatabaseSelector.cpp
    chart/ChartDialog.cpp
    )

ki18n_wrap_ui(chart_DIR_SRCS
    chart/ChartDatabaseSelector.ui
    )

set (commands_DIR_SRCS
    commands/AbstractRegionCommand.cpp
    commands/ApplyFilterCommand.cpp
    commands/AutoFillCommand.cpp
    commands/AutoFilterCommand.cpp
    commands/AutoFormatCommand.cpp
    commands/BorderColorCommand.cpp
    commands/CommentCommand.cpp
    commands/ConditionCommand.cpp
    commands/CopyCommand.cpp
    commands/CSVDataCommand.cpp
    commands/DataManipulators.cpp
    commands/DeleteCommand.cpp
    commands/IndentationCommand.cpp
    commands/LinkCommand.cpp
    commands/MergeCommand.cpp
    commands/NamedAreaCommand.cpp
    commands/PageBreakCommand.cpp
    commands/PasteCommand.cpp
    commands/PrecisionCommand.cpp
    commands/RowColumnManipulators.cpp
    commands/SheetCommands.cpp
    commands/SortManipulator.cpp
    commands/SpellCheckCommand.cpp
    commands/StyleCommand.cpp
    commands/ValidityCommand.cpp
    )

set (database_DIR_SRCS
    #database/Database.cpp
    #database/DatabaseManager.cpp
    database/DatabaseSource.cpp
    database/DatabaseSourceQuery.cpp
    database/DatabaseSourceSql.cpp
    database/DatabaseSourceTable.cpp
    #database/Filter.cpp
    database/FilterPopup.cpp
    )

set (dialogs_DIR_SRCS
    dialogs/AddNamedAreaDialog.cpp
    dialogs/AngleDialog.cpp
    dialogs/AutoFormatDialog.cpp
    dialogs/CharacterSelectDialog.cpp
    dialogs/CommentDialog.cpp
    dialogs/ConditionalDialog.cpp
    dialogs/ConsolidateDialog.cpp
    dialogs/CSVDialog.cpp
    dialogs/DatabaseDialog.cpp
    dialogs/DocumentSettingsDialog.cpp
    dialogs/FindDialog.cpp
    dialogs/FormulaDialog.cpp
    dialogs/GoalSeekDialog.cpp
    dialogs/GotoDialog.cpp
    dialogs/InsertDialog.cpp
    dialogs/LayoutDialog.cpp
    dialogs/LinkDialog.cpp
    dialogs/ListDialog.cpp
    dialogs/NamedAreaDialog.cpp
    dialogs/PasteInsertDialog.cpp
    dialogs/Resize2Dialog.cpp
    dialogs/SeriesDialog.cpp
    dialogs/ShowDialog.cpp
    dialogs/ShowColRowDialog.cpp
    dialogs/SortDialog.cpp
    dialogs/SpecialPasteDialog.cpp
    dialogs/StyleManagerDialog.cpp
    dialogs/SubtotalDialog.cpp
    dialogs/ValidityDialog.cpp
    dialogs/pivot.cpp
    dialogs/pivotfilters.cpp
    dialogs/pivotoptions.cpp
    dialogs/pivotmain.cpp

    )


ki18n_wrap_ui(dialogs_DIR_SRCS
    dialogs/ConsolidateWidget.ui
    dialogs/ConsolidateDetailsWidget.ui
    dialogs/FontWidget.ui
    dialogs/GoalSeekWidget.ui
    dialogs/PositionWidget.ui
    dialogs/ProtectionWidget.ui
    dialogs/SpecialPasteWidget.ui
    dialogs/SortWidget.ui
    dialogs/SortDetailsWidget.ui
    dialogs/SubtotalWidget.ui
    dialogs/SubtotalsDetailsWidget.ui
    dialogs/pivot.ui
    dialogs/pivotfilters.ui
    dialogs/pivotoptions.ui
    dialogs/pivotmain.ui

    )

set (functions_DIR_SRCS
    functions/helper.cpp
    )

if(Qt5DBus_FOUND)
set (interfaces_DIR_SRCS
    interfaces/MapAdaptor.cpp
    interfaces/SheetAdaptor.cpp
    interfaces/ViewAdaptor.cpp
    )
endif()

set (odf_DIR_SRCS
    odf/SheetsOdfDoc.cpp
    odf/SheetsOdfMap.cpp
    odf/SheetsOdfSheet.cpp
    odf/SheetsOdfCell.cpp
    odf/SheetsOdfStyle.cpp
    odf/SheetsOdfRegion.cpp
    odf/SheetsOdfCondition.cpp
    odf/SheetsOdfValidity.cpp
    odf/GenValidationStyle.cpp
    )

set (part_DIR_SRCS
    part/CanvasBase.cpp
    part/Canvas.cpp
    part/CanvasItem.cpp
    part/CellTool.cpp
    part/CellToolFactory.cpp
    #part/Digest.cpp
    part/Doc.cpp
    part/Part.cpp
    part/Factory.cpp
    part/Find.cpp
    part/Headers.cpp
    part/HeaderWidgets.cpp
    part/HeaderItems.cpp
    part/PrintJob.cpp
    part/ToolRegistry.cpp
    part/TabBar.cpp
    part/View.cpp
    part/commands/DefinePrintRangeCommand.cpp
    part/commands/PageLayoutCommand.cpp
    part/dialogs/PageLayoutDialog.cpp
    part/dialogs/PreferenceDialog.cpp
    part/dialogs/SheetPropertiesDialog.cpp
    part/dialogs/SheetSelectPage.cpp
)

ki18n_wrap_ui(part_DIR_SRCS
    part/dialogs/FileOptionsWidget.ui
    part/dialogs/InterfaceOptionsWidget.ui
    part/dialogs/PageLayoutSheetPage.ui
    part/dialogs/SheetPropertiesWidget.ui
    part/dialogs/SheetSelectWidget.ui
)

set (ui_DIR_SRCS
    ui/AbstractSelectionStrategy.cpp
    ui/ActionOptionWidget.cpp
    ui/AutoFillStrategy.cpp
    ui/CellEditorBase.cpp
    ui/CellEditor.cpp
    ui/CellEditorDocker.cpp
    ui/CellToolBase.cpp
    ui/CellToolBase_p.cpp
    ui/CellView.cpp
    ui/DragAndDropStrategy.cpp
    ui/FormulaEditorHighlighter.cpp
    ui/FunctionCompletion.cpp
    ui/ExternalEditor.cpp
    ui/HyperlinkStrategy.cpp
    ui/LocationComboBox.cpp
    ui/MapViewModel.cpp
    ui/MergeStrategy.cpp
    ui/PasteStrategy.cpp
    ui/PixmapCachingSheetView.cpp
    ui/RegionSelector.cpp
    ui/RightToLeftPaintingStrategy.cpp
    ui/Selection.cpp
    ui/SelectionStrategy.cpp
    ui/SheetView.cpp
)

set (calligrasheetscommon_LIB_SRCS
    MapModel.cpp
    PageManager.cpp
    RegionModel.cpp
    tests/inspector.cpp
    ${chart_DIR_SRCS}
    ${commands_DIR_SRCS}
    ${database_DIR_SRCS}
    ${dialogs_DIR_SRCS}
    ${functions_DIR_SRCS}
    ${part_DIR_SRCS}
    ${ui_DIR_SRCS}
    )

if(Qt5DBus_FOUND)
set (calligrasheetscommon_LIB_SRCS
    ${calligrasheetscommon_LIB_SRCS}
    ${interfaces_DIR_SRCS}
    )
endif()

set (calligrasheetsodf_LIB_SRCS
    SheetsDebug.cpp

    part/Digest.cpp
    ApplicationSettings.cpp
    Binding.cpp
    BindingManager.cpp
    BindingModel.cpp
    BindingStorage.cpp
    CalculationSettings.cpp
    Cell.cpp
    CellStorage.cpp
    Cluster.cpp
    Condition.cpp
    ConditionsStorage.cpp
    Currency.cpp
    Damages.cpp
    DependencyManager.cpp
    DocBase.cpp
    Format.cpp
    Formula.cpp
    HeaderFooter.cpp
    Localization.cpp
    Map.cpp
    NamedAreaManager.cpp
    Number.cpp
    PrintSettings.cpp
    ProtectableObject.cpp
    RecalcManager.cpp
    RectStorage.cpp
    Region.cpp
    RowColumnFormat.cpp
    RowFormatStorage.cpp
    RowRepeatStorage.cpp
    ShapeApplicationData.cpp
    Sheet.cpp
    SheetAccessModel.cpp
    SheetModel.cpp
    Style.cpp
    StyleManager.cpp
    StyleStorage.cpp
    Util.cpp
    Validity.cpp
    ValidityStorage.cpp
    Value.cpp
    ValueCalc.cpp
    ValueConverter.cpp
    ValueFormatter.cpp
    ValueParser.cpp

    database/Database.cpp
    database/DatabaseManager.cpp
    database/DatabaseStorage.cpp
    database/Filter.cpp

    ${odf_DIR_SRCS}

    # TODO: move the formula evaluation out of Formula.cpp so these files can move out of libcalligrasheetsodf
    Function.cpp
    FunctionDescription.cpp
    FunctionModule.cpp
    FunctionModuleRegistry.cpp
    FunctionRepository.cpp

    # TODO: move HeaderFooter from SheetPrint to PrintSettings, and replace SheetPrint with PrintSettings in Sheet to get rid of this dependency
    SheetPrint.cpp
    SheetPrint_p.cpp
    )


add_library(calligrasheetsodf SHARED ${calligrasheetsodf_LIB_SRCS})
generate_export_header(calligrasheetsodf
    EXPORT_FILE_NAME sheets_odf_generated_export.h
    BASE_NAME CALLIGRA_SHEETS_ODF
)

target_link_libraries(calligrasheetsodf
    PUBLIC
        komain
        KF5::KDELibs4Support
    PRIVATE
        koplugin
        KF5::Completion
)

set_target_properties(calligrasheetsodf PROPERTIES
   VERSION ${GENERIC_CALLIGRA_LIB_VERSION} SOVERSION ${GENERIC_CALLIGRA_LIB_SOVERSION}
)
install(TARGETS calligrasheetsodf ${INSTALL_TARGETS_DEFAULT_ARGS})


add_library(calligrasheetscommon SHARED ${calligrasheetscommon_LIB_SRCS})
generate_export_header(calligrasheetscommon
    EXPORT_FILE_NAME sheets_common_generated_export.h
    BASE_NAME CALLIGRA_SHEETS_COMMON
)

target_link_libraries(calligrasheetscommon
    PUBLIC
        komain
        calligrasheetsodf
    PRIVATE
        koplugin
        KF5::Completion
        KF5::GuiAddons
        KF5::SonnetCore
        KF5::SonnetUi
        KF5::NotifyConfig
        KF5::KCMUtils
)
if(Qt5Sql_FOUND)
    target_link_libraries(calligrasheetscommon PRIVATE Qt5::Sql)
endif()


set_target_properties(calligrasheetscommon PROPERTIES
    VERSION ${GENERIC_CALLIGRA_LIB_VERSION} SOVERSION ${GENERIC_CALLIGRA_LIB_SOVERSION}
)
install(TARGETS calligrasheetscommon  ${INSTALL_TARGETS_DEFAULT_ARGS})
########### next target ###############

set (calligrasheetspart_PART_SRCS part/Factory_init.cpp )

add_library(calligrasheetspart MODULE ${calligrasheetspart_PART_SRCS})

calligra_part_desktop_to_json(calligrasheetspart sheetspart.desktop)

target_link_libraries(calligrasheetspart calligrasheetscommon )

install(TARGETS calligrasheetspart  DESTINATION ${PLUGIN_INSTALL_DIR}/calligra/parts)

########### install files ###############

install( FILES  calligrasheets.rc calligrasheets_readonly.rc DESTINATION ${KXMLGUI_INSTALL_DIR}/calligrasheets)
install( FILES  ui/CellToolOptionWidgets.xml DESTINATION ${DATA_INSTALL_DIR}/calligrasheets)
install( FILES  calligrasheets.kcfg DESTINATION ${KCFG_INSTALL_DIR} )
install( FILES  calligrasheetsrc DESTINATION ${CONFIG_INSTALL_DIR})

# TODO: with the new embedded JSON data for plugins there is no schema ATM to define extended
# propertiessheets_plugin.desktop, sheets_viewplugin.desktop

if (SHOULD_BUILD_DEVEL_HEADERS)

install( FILES
    sheets_odf_export.h
    ${CMAKE_CURRENT_BINARY_DIR}/sheets_odf_generated_export.h
    sheets_common_export.h
    ${CMAKE_CURRENT_BINARY_DIR}/sheets_common_generated_export.h

    calligra_sheets_limits.h

    Cell.h
    CellStorage.h
    Condition.h
    Currency.h
    DocBase.h
    Format.h
    Global.h
    Map.h
    Number.h
    odf/OdfLoadingContext.h
    PointStorage.h
    PrintSettings.h
    ProtectableObject.h
    RectStorage.h
    Region.h
    RowColumnFormat.h
    RowFormatStorage.h
    RTree.h
    Sheet.h
    Style.h
    Value.h
    ValueCalc.h
    ValueConverter.h
    ValueStorage.h
DESTINATION ${INCLUDE_INSTALL_DIR}/sheets COMPONENT Devel)
install( FILES
    part/CanvasBase.h
    part/CanvasItem.h
    part/CellTool.h
    part/Doc.h
    part/Part.h
    part/Find.h
    part/HeaderItems.h
    part/Headers.h
    part/ToolRegistry.h
    part/View.h
DESTINATION ${INCLUDE_INSTALL_DIR}/calligrasheets/part COMPONENT Devel)
install( FILES
    ui/CellToolBase.h
    ui/CellEditorBase.h
    ui/Selection.h
    ui/SheetView.h
DESTINATION ${INCLUDE_INSTALL_DIR}/calligrasheets/ui COMPONENT Devel)
install( FILES
    database/Database.h
    database/Filter.h
DESTINATION ${INCLUDE_INSTALL_DIR}/calligrasheets/database COMPONENT Devel)
install( FILES
    commands/AbstractRegionCommand.h
    commands/DataManipulators.h
    commands/SortManipulator.h
    dialogs/pivot.h
    dialogs/pivotfilters.h
    dialogs/pivotoptions.h
    dialogs/pivotmain.h
DESTINATION ${INCLUDE_INSTALL_DIR}/calligrasheets/commands COMPONENT Devel)

endif()

endif ()

########### APP ###############

if (SHOULD_BUILD_APP_SHEETS)

=== words/CMakeLists.txt ===
project(words)

add_definitions(-DTRANSLATION_DOMAIN=\"calligrawords\")

include_directories(
    ${KOMAIN_INCLUDES}
)

if (SHOULD_BUILD_PART_WORDS)
    add_subdirectory( templates )
    add_subdirectory( pics )
    add_subdirectory( part )
    add_subdirectory( plugins )
    add_subdirectory( styles )
endif ()

if (SHOULD_BUILD_APP_WORDS)
    add_subdirectory( app )
endif ()

if (BUILD_TESTING)
    add_subdirectory(tests)
endif()

=== doc/sheets/CMakeLists.txt ===
########### install files ###############
#
#
kdoctools_create_handbook(index.docbook INSTALL_DESTINATION ${HTML_INSTALL_DIR}/en SUBDIR calligrasheets)

=== extras/okularodtgenerator/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"okularGenerator_odt\")

include_directories( ${KOMAIN_INCLUDES} ${CMAKE_SOURCE_DIR}/words/part)

## shared odt generator lib

set( kookularGenerator_odt_SRCS OkularOdtGenerator.cpp )

add_library( kookularGenerator_odt SHARED ${kookularGenerator_odt_SRCS})
generate_export_header(kookularGenerator_odt)

target_link_libraries(kookularGenerator_odt
    PUBLIC
        Okular::Core
    PRIVATE
        komain
        kotextlayout
        wordsprivate
)

set_target_properties(kookularGenerator_odt PROPERTIES
   VERSION ${GENERIC_CALLIGRA_LIB_VERSION} SOVERSION ${GENERIC_CALLIGRA_LIB_SOVERSION}
)

install(TARGETS kookularGenerator_odt  ${INSTALL_TARGETS_DEFAULT_ARGS})


## odt generator plugin

kcoreaddons_add_plugin(okularGenerator_odt_calligra
    JSON libokularGenerator_odt.json
    INSTALL_NAMESPACE "okular/generators"
    SOURCES OkularOdtGeneratorPlugin.cpp
)

target_link_libraries( okularGenerator_odt_calligra
    kookularGenerator_odt
)

install( FILES okularOdt_calligra.desktop DESTINATION ${SERVICES_INSTALL_DIR} )
install( PROGRAMS okularApplication_odt_calligra.desktop DESTINATION ${XDG_APPS_INSTALL_DIR} )

=== extras/quickprint/CMakeLists.txt ===

set( QUICK_PRINT_SERVICES
)

if( SHOULD_BUILD_APP_KARBON )
    set( QUICK_PRINT_SERVICES ${QUICK_PRINT_SERVICES} karbon_print.desktop )
endif()

if( SHOULD_BUILD_APP_SHEETS )
    set( QUICK_PRINT_SERVICES ${QUICK_PRINT_SERVICES} sheets_print.desktop )
endif()

if( SHOULD_BUILD_APP_STAGE )
    set( QUICK_PRINT_SERVICES ${QUICK_PRINT_SERVICES} stage_print.desktop )
endif()

if( SHOULD_BUILD_APP_WORDS )
    set( QUICK_PRINT_SERVICES ${QUICK_PRINT_SERVICES} words_print.desktop )
endif()

install( FILES ${QUICK_PRINT_SERVICES} DESTINATION ${SERVICES_INSTALL_DIR}/ServiceMenus/calligra)

=== extras/thumbnail/CMakeLists.txt ===
# the general thumbnailers, used for a lot of file types (see filters/*)
include_directories(
    ${KOMAIN_INCLUDES}
)

set(calligrathumbnail_SRCS calligracreator.cpp)
add_library(calligrathumbnail MODULE ${calligrathumbnail_SRCS})
target_link_libraries(calligrathumbnail komain KF5::KIOWidgets)
install(TARGETS calligrathumbnail  DESTINATION ${PLUGIN_INSTALL_DIR})

if( SHOULD_BUILD_APP_KARBON )
    set(calligraimagethumbnail_SRCS calligracreator.cpp)
    add_library(calligraimagethumbnail MODULE ${calligraimagethumbnail_SRCS})
    set_target_properties(calligraimagethumbnail PROPERTIES COMPILE_FLAGS "-DNO_ICON_BLENDING")
    target_link_libraries(calligraimagethumbnail komain KF5::KIOWidgets)
    install(TARGETS calligraimagethumbnail  DESTINATION ${PLUGIN_INSTALL_DIR})
endif()

# thumbnailing for the native opendocument formats
set( THUMBNAIL_SERVICES
)

# karbon loads odg natively, so if it is built add support for odg
if( SHOULD_BUILD_APP_KARBON )
    list( APPEND THUMBNAIL_SERVICES calligra_odg_thumbnail.desktop )
endif()

if( SHOULD_BUILD_PART_SHEETS )
    list( APPEND THUMBNAIL_SERVICES sheets_ods_thumbnail.desktop )
endif()

if( SHOULD_BUILD_PART_STAGE )
    list( APPEND THUMBNAIL_SERVICES stage_odp_thumbnail.desktop )
endif()

if( SHOULD_BUILD_PART_WORDS )
    list( APPEND THUMBNAIL_SERVICES words_odt_thumbnail.desktop )
endif()

install( FILES ${THUMBNAIL_SERVICES} DESTINATION ${SERVICES_INSTALL_DIR})

=== karbon/ui/CMakeLists.txt ===
include_directories(
        ${KOPAGEAPP_INCLUDES}
        ${KOODF_INCLUDES}
        ${KOMAIN_INCLUDES}
        ${CMAKE_SOURCE_DIR}/karbon/
        ${CMAKE_SOURCE_DIR}/karbon/ui
        ${CMAKE_SOURCE_DIR}/karbon/ui/dialogs
        ${CMAKE_SOURCE_DIR}/karbon/ui/dockers
        ${CMAKE_SOURCE_DIR}/karbon/ui/widgets
        ${CMAKE_SOURCE_DIR}/karbon/ui/commands
)

set(karbonui_SRCS
    KarbonUiDebug.cpp
    KarbonFactory.cpp
    KarbonDocument.cpp
    KarbonPart.cpp
    KarbonView.cpp 
    ProxyView.cpp

    KarbonDocumentMergeCommand.cpp
    
    dialogs/KarbonConfigureDialog.cpp

    widgets/KarbonSmallStylePreview.cpp
    widgets/KarbonPaletteBarWidget.cpp
    widgets/KarbonPaletteWidget.cpp
    widgets/KarbonConfigInterfacePage.cpp
)

add_library( karbonui SHARED ${karbonui_SRCS} )
generate_export_header(karbonui BASE_NAME karbonui)

target_link_libraries(karbonui
    PUBLIC
        karboncommon
        flake
    PRIVATE
        kopageapp
        kowidgets
        koodf
        koplugin
        KF5::IconThemes
        KF5::GuiAddons
)

set_target_properties(karbonui PROPERTIES VERSION ${GENERIC_CALLIGRA_LIB_VERSION} SOVERSION ${GENERIC_CALLIGRA_LIB_SOVERSION} )

install(TARGETS karbonui  ${INSTALL_TARGETS_DEFAULT_ARGS})

=== libs/flake/CMakeLists.txt ===
project(flake)

include_directories(${FLAKE_INCLUDES} )

add_subdirectory(styles)
if(BUILD_TESTING)
    add_subdirectory(tests)
endif()
add_subdirectory(pics)

set(flake_SRCS
    KoGradientHelper.cpp
    KoFlake.cpp
    KoCanvasBase.cpp
    KoResourceManager_p.cpp
    KoCanvasResourceManager.cpp
    KoDocumentResourceManager.cpp
    KoCanvasObserverBase.cpp
    KoCanvasSupervisor.cpp
    KoCutController.cpp
    KoCopyController.cpp
    KoDockFactoryBase.cpp
    KoDockRegistry.cpp
    KoDataCenterBase.cpp
    KoInsets.cpp
    KoPasteController.cpp
    KoGuidesData.cpp
    KoGridData.cpp
    KoPathShape.cpp
    KoPathPoint.cpp
    KoPathSegment.cpp
    KoSelection.cpp
    KoShape.cpp
    KoShapeAnchor.cpp
    KoShapeBasedDocumentBase.cpp
    KoShapeApplicationData.cpp
    KoShapeContainer.cpp
    KoShapeContainerModel.cpp
    KoShapeContainerDefaultModel.cpp
    KoShapeGroup.cpp
    KoShapeManagerPaintingStrategy.cpp
    KoShapeManager.cpp
    KoShapePaintingContext.cpp
    KoShapePainter.cpp
    KoFrameShape.cpp
    KoUnavailShape.cpp
    KoMarkerData.cpp
    KoMarker.cpp
    KoMarkerCollection.cpp
    KoMarkerSharedLoadingData.cpp
    #KoUnavailData.cpp
    #KoUnavailCollection.cpp
    KoToolBase.cpp
    KoCanvasController.cpp
    KoCanvasControllerWidget.cpp
    KoCanvasControllerWidgetViewport_p.cpp
    KoShapeRegistry.cpp
    KoDeferredShapeFactoryBase.cpp
    KoToolFactoryBase.cpp
    KoPathShapeFactory.cpp
    KoShapeFactoryBase.cpp
    KoShapeUserData.cpp
    KoParameterShape.cpp
    KoPointerEvent.cpp
    KoShapeController.cpp
    KoToolSelection.cpp
    KoShapeLayer.cpp
    KoPostscriptPaintDevice.cpp
    KoInputDevice.cpp
    KoToolManager_p.cpp
    KoToolManager.cpp
    KoToolRegistry.cpp
    KoToolProxy.cpp
    KoShapeSavingContext.cpp
    KoShapeLoadingContext.cpp
    KoLoadingShapeUpdater.cpp
    KoPathShapeLoader.cpp
    KoShapeStrokeModel.cpp
    KoShapeStroke.cpp
    KoShapeBackground.cpp
    KoColorBackground.cpp
    KoGradientBackground.cpp
    KoOdfGradientBackground.cpp
    KoHatchBackground.cpp
    KoPatternBackground.cpp
    KoShapeConfigWidgetBase.cpp
    KoShapeConfigFactoryBase.cpp
    KoDrag.cpp
    KoDragOdfSaveHelper.cpp
    KoShapeOdfSaveHelper.cpp
    KoShapePaste.cpp
    KoConnectionPoint.cpp
    KoConnectionShape.cpp
    KoConnectionShapeLoadingUpdater.cpp
    KoConnectionShapeFactory.cpp
    KoConnectionShapeConfigWidget.cpp
    KoSnapGuide.cpp
    KoSnapProxy.cpp
    KoSnapStrategy.cpp
    KoSnapData.cpp
    SnapGuideConfigWidget.cpp
    KoShapeShadow.cpp
    KoSharedLoadingData.cpp
    KoSharedSavingData.cpp
    KoViewConverter.cpp
    KoInputDeviceHandler.cpp
    KoInputDeviceHandlerEvent.cpp
    KoInputDeviceHandlerRegistry.cpp
    KoEventAction.cpp
    KoEventActionFactoryBase.cpp
    KoEventActionRegistry.cpp
    KoImageData.cpp
    KoImageData_p.cpp
    KoImageCollection.cpp
    KoOdfWorkaround.cpp
    KoFilterEffect.cpp
    KoFilterEffectStack.cpp
    KoFilterEffectFactoryBase.cpp
    KoFilterEffectRegistry.cpp
    KoFilterEffectConfigWidgetBase.cpp
    KoFilterEffectRenderContext.cpp
    KoFilterEffectLoadingContext.cpp
    KoTextShapeDataBase.cpp
    KoTosContainer.cpp
    KoTosContainerModel.cpp
    KoClipPath.cpp
    KoCurveFit.cpp
    KoAnnotationLayoutManager.cpp
    commands/KoShapeGroupCommand.cpp
    commands/KoShapeAlignCommand.cpp
    commands/KoShapeBackgroundCommand.cpp
    commands/KoShapeCreateCommand.cpp
    commands/KoShapeDeleteCommand.cpp
    commands/KoShapeDistributeCommand.cpp
    commands/KoShapeLockCommand.cpp
    commands/KoShapeMoveCommand.cpp
    commands/KoShapeShearCommand.cpp
    commands/KoShapeSizeCommand.cpp
    commands/KoShapeStrokeCommand.cpp
    commands/KoShapeUngroupCommand.cpp
    commands/KoShapeReorderCommand.cpp
    commands/KoShapeKeepAspectRatioCommand.cpp
    commands/KoPathBaseCommand.cpp
    commands/KoPathPointMoveCommand.cpp
    commands/KoPathControlPointMoveCommand.cpp
    commands/KoPathPointTypeCommand.cpp
    commands/KoPathPointRemoveCommand.cpp
    commands/KoPathPointInsertCommand.cpp
    commands/KoPathSegmentBreakCommand.cpp
    commands/KoPathBreakAtPointCommand.cpp
    commands/KoPathSegmentTypeCommand.cpp
    commands/KoPathCombineCommand.cpp
    commands/KoSubpathRemoveCommand.cpp
    commands/KoSubpathJoinCommand.cpp
    commands/KoParameterHandleMoveCommand.cpp
    commands/KoParameterToPathCommand.cpp
    commands/KoShapeTransformCommand.cpp
    commands/KoPathFillRuleCommand.cpp
    commands/KoConnectionShapeTypeCommand.cpp
    commands/KoShapeShadowCommand.cpp
    commands/KoPathReverseCommand.cpp
    commands/KoEventActionAddCommand.cpp
    commands/KoEventActionRemoveCommand.cpp
    commands/KoShapeRenameCommand.cpp
    commands/KoShapeRunAroundCommand.cpp
    commands/KoPathPointMergeCommand.cpp
    commands/KoShapeTransparencyCommand.cpp
    commands/KoShapeClipCommand.cpp
    commands/KoShapeUnclipCommand.cpp
    commands/KoPathShapeMarkerCommand.cpp
    commands/KoShapeConnectionChangeCommand.cpp
    tools/KoCreateShapeStrategy.cpp
    tools/KoPathToolFactory.cpp
    tools/KoPathTool.cpp
    tools/KoPathToolSelection.cpp
    tools/KoPathToolHandle.cpp
    tools/PathToolOptionWidget.cpp
    tools/KoPathPointRubberSelectStrategy.cpp
    tools/KoPathPointMoveStrategy.cpp
    tools/KoPathConnectionPointStrategy.cpp
    tools/KoPathControlPointMoveStrategy.cpp
    tools/KoParameterChangeStrategy.cpp
    tools/KoZoomTool.cpp
    tools/KoZoomToolFactory.cpp
    tools/KoZoomToolWidget.cpp
    tools/KoZoomStrategy.cpp
    tools/KoPanTool.cpp
    tools/KoPanToolFactory.cpp
    tools/KoInteractionTool.cpp
    tools/KoInteractionStrategy.cpp
    tools/KoCreateShapesTool.cpp
    tools/KoCreateShapesToolFactory.cpp
    tools/KoShapeRubberSelectStrategy.cpp
    tools/KoPathSegmentChangeStrategy.cpp
    svg/SvgUtil.cpp
    svg/SvgGraphicContext.cpp
    svg/SvgSavingContext.cpp
    svg/SvgWriter.cpp
    svg/SvgStyleWriter.cpp
    svg/SvgShape.cpp
    svg/SvgParser.cpp
    svg/SvgStyleParser.cpp
    svg/SvgGradientHelper.cpp
    svg/SvgPatternHelper.cpp
    svg/SvgFilterHelper.cpp
    svg/SvgCssHelper.cpp
    svg/SvgClipPathHelper.cpp
    svg/SvgLoadingContext.cpp
    svg/SvgShapeFactory.cpp

    FlakeDebug.cpp
)

ki18n_wrap_ui(flake_SRCS
    tools/PathToolOptionWidgetBase.ui
    KoConnectionShapeConfigWidget.ui
    SnapGuideConfigWidget.ui
    tools/KoZoomToolWidget.ui
)

add_library(flake SHARED ${flake_SRCS})
generate_export_header(flake BASE_NAME flake)

target_link_libraries(flake
    PUBLIC
        pigmentcms
        kowidgetutils
        koodf
        kundo2
    PRIVATE
        koplugin
        KF5::IconThemes
        KF5::ConfigCore
        KF5::WidgetsAddons
        KF5::CoreAddons
        Qt5::Svg
)

set_target_properties(flake PROPERTIES
    VERSION ${GENERIC_CALLIGRA_LIB_VERSION} SOVERSION ${GENERIC_CALLIGRA_LIB_SOVERSION}
)

########### install files ###############

install(TARGETS flake  ${INSTALL_TARGETS_DEFAULT_ARGS})
# TODO: with the new embedded JSON data for plugins there is no schema ATM to define extended properties
#     flake.desktop
#     flaketool.desktop
#     flakeshape.desktop
#     flakedevice.desktop
#     presentationeventaction.desktop
#     scripteventaction.desktop
#     filtereffect.desktop

if (SHOULD_BUILD_DEVEL_HEADERS)

install(
    FILES
    KoCanvasBase.h
    KoCanvasController.h
    KoCanvasControllerWidget.h
    KoCanvasObserverBase.h
    KoCanvasSupervisor.h
    KoCanvasResourceManager.h
    KoDocumentResourceManager.h
    KoConnectionPoint.h
    KoCopyController.h
    KoCutController.h
    KoDataCenterBase.h
    KoDockFactoryBase.h
    KoDockRegistry.h
    KoDeferredShapeFactoryBase.h
    KoDrag.h
    KoDragOdfSaveHelper.h
    KoFlake.h
    KoFrameShape.h
    KoGuidesData.h
    KoGridData.h
    KoImageCollection.h
    KoImageData.h
    KoInputDevice.h
    KoInsets.h
    KoPathSegment.h
    KoPointerEvent.h
    KoRTree.h
    KoSelection.h
    KoShape.h
    KoShapeAnchor.h
    KoShapeStrokeModel.h
    KoToolSelection.h
    KoShapeContainer.h
    KoShapeContainerModel.h
    KoShapeContainerDefaultModel.h
    KoShapeController.h
    KoShapeBasedDocumentBase.h
    KoShapeFactoryBase.h
    KoShapeGroup.h
    KoShapeLayer.h
    KoShapePainter.h
    KoShapeLoadingContext.h
    KoShapeOdfSaveHelper.h
    KoLoadingShapeUpdater.h
    KoShapeConfigWidgetBase.h
    KoShapeManager.h
    KoShapeManagerPaintingStrategy.h
    KoShapeRegistry.h
    KoShapeSavingContext.h
    KoShapeUserData.h
    KoShapeApplicationData.h
    KoSharedSavingData.h
    KoTextShapeDataBase.h
    KoToolBase.h
    KoToolManager.h
    KoToolFactoryBase.h
    KoToolProxy.h
    KoToolRegistry.h
    KoFilterEffect.h
    KoFilterEffectStack.h
    KoFilterEffectFactoryBase.h
    KoFilterEffectRegistry.h
    KoFilterEffectConfigWidgetBase.h
    KoFilterEffectRenderContext.h
    KoFilterEffectLoadingContext.h
    commands/KoEventActionAddCommand.h
    commands/KoEventActionRemoveCommand.h
    commands/KoParameterToPathCommand.h
    commands/KoPathCombineCommand.h
    commands/KoPathControlPointMoveCommand.h
    commands/KoPathFillRuleCommand.h
    commands/KoPathPointInsertCommand.h
    commands/KoPathPointMergeCommand.h
    commands/KoPathPointMoveCommand.h
    commands/KoPathPointRemoveCommand.h
    commands/KoPathPointTypeCommand.h
    commands/KoPathReverseCommand.h
    commands/KoPathSegmentTypeCommand.h
    commands/KoShapeAlignCommand.h
    commands/KoShapeBackgroundCommand.h
    commands/KoShapeStrokeCommand.h
    commands/KoShapeCreateCommand.h
    commands/KoShapeDeleteCommand.h
    commands/KoShapeDistributeCommand.h
    commands/KoShapeGroupCommand.h
    commands/KoShapeMoveCommand.h
    commands/KoShapeRenameCommand.h
    commands/KoShapeReorderCommand.h
    commands/KoShapeShadowCommand.h
    commands/KoShapeShearCommand.h
    commands/KoShapeSizeCommand.h
    commands/KoShapeTransformCommand.h
    commands/KoShapeUngroupCommand.h
    commands/KoSubpathRemoveCommand.h
    commands/KoPathShapeMarkerCommand.h
    tools/KoInteractionTool.h
    tools/KoPanTool.h
    KoViewConverter.h
    DESTINATION
    ${INCLUDE_INSTALL_DIR}/calligra COMPONENT Devel
)

endif()

=== debian/changelog ===
calligra (1:3.2.1+dfsg-9ubuntu1) oracular; urgency=medium

  * Build without okular odp/odt backends. Okular is now Qt6/KF6, so the
    backends are not buildable until we have the Qt6/KF6 port of
    calligra:
    - debian/control: Drop optional okular-dev build dependency.
    - debian/control: Do not ship oular-backend-odp and okular-backend-
      odt packages.
  * Update watch file as this release has been moved to 'Attic' on
    download.kde.org.

 -- Rik Mills <rikmills@kde.org>  Tue, 17 Sep 2024 08:01:49 +0100

calligra (1:3.2.1+dfsg-9) unstable; urgency=medium

  [ Pino Toscano ]
  * Add the configuration for the CI on salsa.
  * Switch the transitional pkg-config build dependency to pkgconf.
  * Bump Standards-Version to 4.7.0, no changes required.

  [ Andreas Hasenack ]
  * Add patch to fix build with poppler 24.06. (Closes: #1074386)

 -- Pino Toscano <pino@debian.org>  Mon, 19 Aug 2024 18:55:39 +0200

=== debian/control ===
Source: calligra
Section: kde
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Pino Toscano <pino@debian.org>,
Build-Depends: cmake (>= 3.16~),
               debhelper-compat (= 13),
               extra-cmake-modules (>= 5.19.0),
               gettext,
               libboost-dev,
               libboost-system-dev,
               libeigen3-dev,
               libetonyek-dev,
               libfontconfig-dev,
               libfreetype-dev,
               libgit2-dev,
               libglib2.0-dev,
               libgsl-dev,
               libkchart-dev (>= 2.7.0~),
               libkf5activities-dev (>= 5.7.0),
               libkf5archive-dev (>= 5.7.0),
               libkf5akonadi-dev,
               libkf5attica-dev,
               libkf5calendarcore-dev,
               libkf5codecs-dev (>= 5.7.0),
               libkf5completion-dev (>= 5.7.0),
               libkf5config-dev (>= 5.7.0),
               libkf5configwidgets-dev (>= 5.7.0),
               libkf5contacts-dev,
               libkf5coreaddons-dev (>= 5.7.0),
               libkf5dbusaddons-dev (>= 5.7.0),
               libkf5doctools-dev (>= 5.103.0-2~),
               libkf5guiaddons-dev (>= 5.7.0),
               libkf5i18n-dev (>= 5.7.0),
               libkf5iconthemes-dev (>= 5.7.0),
               libkf5itemviews-dev (>= 5.7.0),
               libkf5jobwidgets-dev (>= 5.7.0),
               libkf5kcmutils-dev (>= 5.7.0),
               libkf5kdelibs4support-dev (>= 5.7.0),
               libkf5khtml-dev (>= 5.7.0),
               libkf5kio-dev (>= 5.7.0),
               libkf5notifications-dev (>= 5.7.0),
               libkf5notifyconfig-dev (>= 5.7.0),
               libkf5parts-dev (>= 5.7.0),
               libkf5sonnet-dev (>= 5.7.0),
               libkf5textwidgets-dev (>= 5.7.0),
               libkf5wallet-dev (>= 5.7.0),
               libkf5widgetsaddons-dev (>= 5.7.0),
               libkf5windowsystem-dev (>= 5.7.0),
               libkf5xmlgui-dev (>= 5.7.0),
               libkproperty3-dev (>= 3.1.0~),
               libkreport3-dev (>= 3.1.0~),
               liblcms2-dev (>= 2.4),
               libodfgen-dev,
               libopenexr-dev,
               libphonon4qt5-dev,
               libphonon4qt5experimental-dev,
               libpoppler-private-dev (>= 0.83.0~),
               libpoppler-qt5-dev (>= 0.83.0~),
               libqca-qt5-2-dev,
               libqt5opengl5-dev (>= 5.3.0),
               libqt5svg5-dev (>= 5.3.0),
               libqt5x11extras5-dev (>= 5.3.0),
               libspnav-dev,
               libvisio-dev (>= 0.1),
               libwpd-dev (>= 0.10),
               libwpg-dev (>= 0.3),
               libwps-dev (>= 0.4),
               libx11-dev,
               libxml2-dev,
#               okular-dev (>= 4:17.08),
               pkgconf,
               pkg-kde-tools (>= 0.15.16),
               pstoedit,
               qtbase5-dev (>= 5.3.0),
               qtdeclarative5-dev (>= 5.3.0),
               shared-mime-info,
               zlib1g-dev
Standards-Version: 4.7.0
Homepage: https://www.calligra.org/
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/calligra.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/calligra
Rules-Requires-Root: no

Package: calligra
Architecture: all
Depends: calligrasheets (>= ${source:Version}),
         calligrastage (>= ${source:Version}),
         calligrawords (>= ${source:Version}),
         karbon (>= ${source:Version}),
         ${misc:Depends}
Description: extensive productivity and creative suite
 Calligra Suite is a set of applications written to help you to accomplish
 your work. It includes office applications such as a word processor,
 a spreadsheet, a presentation program, a database application, etc., and
 raster and vector graphics tools.
 .
 This metapackage provides all the components of the Calligra Suite.

Package: karbon
Architecture: any
Section: graphics
Depends: calligra-libs (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: pstoedit
Homepage: https://www.calligra.org/karbon/
Description: vector graphics application for the Calligra Suite
 Karbon is a vector drawing application with an user interface that is easy to
 use, highly customizable and extensible. That makes Karbon a great application
 for users starting to explore the world of vector graphics as well as for
 artists wanting to create breathtaking vector art. Features include:
 .
  * Loading support for ODG, SVG, WMF, WPG, EPS/PS
  * Writing support for ODG, SVG, WMF, PNG, PDF
  * Customizable user interface with freely placeable toolbars and dockers
  * Layer docker for easy handling of complex documents including preview
    thumbnails, support for grouping shapes via drag and drop,
    controlling visibility of shapes or locking
  * Advanced path editing tool with great on-canvas editing capabilities
  * Various drawing tools for creating path shapes including a draw path
    tool and a pencil tool, as well as a calligraphy drawing tool
  * Gradient and pattern tools for easy on-canvas editing of gradient and
    pattern styles
  * Top notch snapping facilities for guided drawing and editing (e.g.
    snapping to grid, guide lines, path nodes, bounding boxes, orthogonal
    positions, intersections of path shapes or extensions of lines and
    paths)
  * Many predefined basic shapes included, such as circle/ellipse, star or
    rectangle
  * Artistic text shape with support for following path outlines
    (i.e. text on path)
  * Complex path operations and effects like Boolean set operations,
    path flattening, rounding and refining as well as whirl/pinch effects
  * Extensible by writing plugins for new tools, shapes and dockers
 .
 This package is part of the Calligra Suite.

Package: calligrasheets
Architecture: any
Section: math
Depends: calligra-libs (= ${binary:Version}),
         calligrasheets-data (>= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: khelpcenter, python, ruby
Homepage: https://www.calligra.org/sheets/
Description: spreadsheet for the Calligra Suite
 Tables is a powerful spreadsheet application.  It is scriptable and
 provides both table-oriented sheets and support for complex mathematical
 formulae and statistics. It is the successor of KSpread.
 .
 This package is part of the Calligra Suite.

Package: calligrasheets-data
Architecture: all
Section: math
Depends: ${misc:Depends}
Homepage: https://www.calligra.org/sheets/
Description: data files for Sheets spreadsheet
 This package contains architecture-independent data files for Sheets,
 the spreadsheet shipped with the Calligra Suite.
 .
 See the calligrasheets package for further information.
 .
 This package is part of the Calligra Suite.

Package: calligrawords
Architecture: any
Section: text
Depends: calligra-libs (= ${binary:Version}),
         calligrawords-data (>= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Homepage: https://www.calligra.org/words/
Description: word processor for the Calligra Suite
 Words is a FrameMaker-like word processing and desktop publishing
 application. It is capable of creating polished and professional
 looking documents. It can be used for desktop publishing, but also for
 "normal" word processing, like writing letters, reports and so on.
 .
 This package is part of the Calligra Suite.

Package: calligrawords-data
Architecture: all
Section: text
Depends: ${misc:Depends}
Homepage: https://www.calligra.org/words/
Description: data files for Words word processor
 This package contains architecture-independent data files for Words,
 the word processor shipped with the Calligra Suite.
 .
 See the calligrawords package for further information.
 .
 This package is part of the Calligra Suite.

Package: calligrastage
Architecture: any
Depends: calligra-libs (= ${binary:Version}),
         calligrastage-data (>=${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: khelpcenter
Homepage: https://www.calligra.org/stage/
Description: presentation program for the Calligra Suite
 Stage is an easy to use yet still flexible presentation application. You can
 easily create presentations containing a rich variety of elements, from
 graphics to text, from charts to images. Stage is extensible through a
 plugin system, so it is easy to add new effects, new content elements or even
 new ways of managing your presentation.
 .
 Stage natively uses the OpenDocument file format standard, for easy
 interchange with all ODF supporting applications, which includes Microsoft
 Office. Examples of its easy-to-use features are support for layouts, a
 special slide overview view during presentations for the presenter, support
 for many different master sliders in one presentation, cool transitions and
 a useful notes feature.
 .
 This package is part of the Calligra Suite.

Package: calligrastage-data
Architecture: all
Depends: ${misc:Depends}
Homepage: https://www.calligra.org/stage/
Description: data files for Calligra Stage
 This package contains architecture-independent data files for Stage,
 the presentation program shipped with the Calligra Suite.
 .
 See the calligrastage package for further information.
 .
 This package is part of the Calligra Suite.

Package: calligra-libs
Section: libs
Architecture: any
Depends: calligra-data (>= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: fonts-lyx, libqca-qt5-2-plugins
Suggests: texlive, wordnet
Description: common libraries and binaries for the Calligra Suite
 This package provides the libraries and binaries that are shared amongst
 the various components of Calligra.
 .
 This package is part of the Calligra Suite.

Package: calligra-data
Section: libs
Architecture: all
Depends: ${misc:Depends}
Suggests: khelpcenter
Description: common shared data for the Calligra Suite
 This package provides the architecture-independent data that is shared
 amongst the various components of Calligra.
 .
 This package is part of the Calligra Suite.

#Package: okular-backend-odp
#Architecture: any
#Section: graphics
#Depends: calligra-libs (= ${binary:Version}),
#         ${misc:Depends},
#         ${shlibs:Depends}
#Recommends: okular
#Enhances: okular
#Description: Okular backend for ODP documents
# This package provides a backend for Okular to view OpenDocument Presentation
# (ODP) documents, but also PowerPoint and PPTX documents.
# .
# This package is part of the Calligra Suite.

#Package: okular-backend-odt
#Architecture: any
#Section: graphics
#Depends: calligra-libs (= ${binary:Version}),
#         ${misc:Depends},
#         ${shlibs:Depends}
#Recommends: okular
#Enhances: okular
#Description: Okular backend for ODT documents
# This package provides a backend for Okular to view OpenDocument Text
# (ODT) documents, but also DOC, DOCX, RTF and WPD documents.
# .
# This package is part of the Calligra Suite.

Package: calligra-gemini
Architecture: any
Depends: calligra-libs (= ${binary:Version}),
         calligra-gemini-data (>= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Homepage: https://www.calligra.org/gemini/
Description: unified interface for stage and words
 Calligra Gemini provide a unified applications which combines
 traditional desktop application and touch friendly interface for
 the Words and Stage components.
 .
 This package is part of the Calligra Suite.

Package: calligra-gemini-data
Architecture: all
Depends: ${misc:Depends}, texlive-fonts-extra
Homepage: https://www.calligra.org/gemini/
Description: Calligra Gemini - data files
 Calligra Gemini provide a unified applications which combines
 traditional desktop application and touch friendly interface for
 the Words and Stage components.
 .
 This package provides data files for Calligra Gemini.

=== debian/watch ===
version=4

opts=\
repacksuffix=+dfsg,\
dversionmangle=s/\+dfsg\d*$// \
 https://download.kde.org/Attic/calligra/([\d\.]+)/calligra-([\d\.]+)\.tar\.xz
